#include "Project.h"






// NOTE: Checks player input for activity
//
void check_input()
{
 float move_rate    =  5.0;
 int moving         = -1;



 // Map inputs to virtual d_pad
 // These will be picked up in menus, etc
 //
 if(!flags.gamepad) {
     if(IsKeyDown(KEY_UP) || IsKeyDown(KEY_W))    { actors[puppet].d_pad[0] = 1; }
     else                                         { actors[puppet].d_pad[0] = 0; actors[puppet].d_repeat[0] = 0; }

     if(IsKeyDown(KEY_LEFT) || IsKeyDown(KEY_A))  { actors[puppet].d_pad[1] = 1; }
     else                                         { actors[puppet].d_pad[1] = 0; actors[puppet].d_repeat[1] = 0; }

     if(IsKeyDown(KEY_DOWN) || IsKeyDown(KEY_S))  { actors[puppet].d_pad[2] = 1; }
     else                                         { actors[puppet].d_pad[2] = 0; actors[puppet].d_repeat[2] = 0; }

     if(IsKeyDown(KEY_RIGHT) || IsKeyDown(KEY_D)) { actors[puppet].d_pad[3] = 1; }
     else                                         { actors[puppet].d_pad[3] = 0; actors[puppet].d_repeat[3] = 0; }

     if(IsKeyDown(KEY_Z)) { actors[puppet].buttons[0] = 1; }
     else                 { actors[puppet].buttons[0] = 0; actors[puppet].b_repeat[0] = 0; }

     if(IsKeyDown(KEY_X)) { actors[puppet].buttons[1] = 1; }
     else                 { actors[puppet].buttons[1] = 0; actors[puppet].b_repeat[1] = 0; }

     if(IsKeyDown(KEY_C)) { actors[puppet].buttons[2] = 1; }
     else                 { actors[puppet].buttons[2] = 0; actors[puppet].b_repeat[2] = 0; }

     if(IsKeyDown(KEY_V)) { actors[puppet].buttons[3] = 1; }
     else                 { actors[puppet].buttons[3] = 0; actors[puppet].b_repeat[3] = 0; }

                    }

 else {
     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_UP))    { actors[puppet].d_pad[0] = 1; }
     else                                                       { actors[puppet].d_pad[0] = 0; actors[puppet].d_repeat[0] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_LEFT))  { actors[puppet].d_pad[1] = 1; }
     else                                                       { actors[puppet].d_pad[1] = 0; actors[puppet].d_repeat[1] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_DOWN))  { actors[puppet].d_pad[2] = 1; }
     else                                                       { actors[puppet].d_pad[2] = 0; actors[puppet].d_repeat[2] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_LEFT_FACE_RIGHT)) { actors[puppet].d_pad[3] = 1; }
     else                                                       { actors[puppet].d_pad[3] = 0; actors[puppet].d_repeat[3] = 0; }


     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_UP))    { actors[puppet].buttons[0] = 1; }
     else                                                        { actors[puppet].buttons[0] = 0; actors[puppet].b_repeat[0] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_LEFT))  { actors[puppet].buttons[1] = 1; }
     else                                                        { actors[puppet].buttons[1] = 0; actors[puppet].b_repeat[1] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_DOWN))  { actors[puppet].buttons[2] = 1; }
     else                                                        { actors[puppet].buttons[2] = 0; actors[puppet].b_repeat[2] = 0; }

     if(IsGamepadButtonDown(0, GAMEPAD_BUTTON_RIGHT_FACE_RIGHT)) { actors[puppet].buttons[3] = 1; }
     else                                                        { actors[puppet].buttons[3] = 0; actors[puppet].b_repeat[3] = 0; }
      }


 // Only check these controls if the game is active
 //
 if(flags.game_mode != 2) { return; }


     if(actors[puppet].d_pad[0]) { // Up
         moving = 0;
         if(actors[puppet].pos.y > 150) { actors[puppet].pos.y -= move_rate; }
                                 }

     if(actors[puppet].d_pad[2]) { // Down
         moving = 2;
         if(actors[puppet].pos.y < SCREEN_H - 300) { actors[puppet].pos.y += move_rate; }
                                 }


     if(actors[puppet].d_pad[1]) { // Left
         moving = 1;
         if(actors[puppet].pos.x > 0) { actors[puppet].pos.x -= (move_rate * 1.2); }
                                 }

     if(actors[puppet].d_pad[3]) { // Right
         moving = 3;
         if(actors[puppet].pos.x < SCREEN_W) { actors[puppet].pos.x += (move_rate * 1.2); }
                                 }



 // Pressing (and holding) Z shoots radiance if you've got it equipped
 //
 if(flags.shot_ready > 0) { flags.shot_ready--; }
 else {
     if(actors[puppet].buttons[0]) { // Z button
         if(!actors[puppet].flip) { // Right shot
             fire_shot(actors[puppet].pos.x + 58, actors[puppet].pos.y + 1, actors[puppet].pos.z + 20, 0);
                                  }
         else { // Left shot
             fire_shot(actors[puppet].pos.x - 58, actors[puppet].pos.y + 1, actors[puppet].pos.z + 20, 1);
              }
         flags.shot_ready = 5;
                                   }
      }

 if(!actors[puppet].buttons[0]) { flags.rapid_fire = 0; }


 if(actors[puppet].buttons[1] && !actors[puppet].b_repeat[1]) {
     actors[puppet].flip ^= 1;
     actors[puppet].b_repeat[1] = 1;

     if(actors[puppet].flip) {
         actors[actors[puppet].extra[0]].follow_x = 96;
         actors[actors[puppet].extra[0]].flip = 1;
                             }
     else {
         actors[actors[puppet].extra[0]].follow_x = -96;
         actors[actors[puppet].extra[0]].flip = 0;
                             }
                                                              }

 // Set animation for player
 //
 if(puppet != -1) {
     if(actors[puppet].buttons[0]) { actors[puppet].cel_x = 4; }
     else                          { actors[puppet].cel_x = 1; }
                  }


 return;
}






void check_delta_updates()
{
 float clock_ticks  = ((BASE_TICKS * flags.game_speed) / 60.0);  // In future, make FPS variable by user. Change here
 float ms_per_frame = (1.000 / 60.0);       // Ditto
 float updates      = 0.0;
 int   i            = 0;

 // Get delta time
 //
 flags.delta = GetFrameTime();
 flags.game_time += (flags.delta * 60.0);

 // Set up delta factor (this should be damn close to 1.0)
 //
 if(flags.delta_factor > 0.01) { flags.delta_factor = (flags.delta / ms_per_frame); }
 else                          { flags.delta_factor = 1.000;                        }



 // Also add in leftovers from last frame that didn't make the cut.
 //
 updates = (clock_ticks * flags.delta_factor);
 updates += flags.timing_leftover;


 // Round down to store our total updates for this frame
 // Partial values (i.e. x < 1.0) will get stored away for next cycle
 //
 flags.last_updates    = (int)updates;
 flags.timing_leftover = fmod(updates, 1.00);


 // Do as many updates as we've clocked in
 //
 for(i=0; i<flags.last_updates; i++) {
     check_shaders();
     check_input();

     #ifdef USE_ANIMATIONS
         check_animations();
     #endif

     #ifdef USE_TEXTBOX
         check_textbox();
     #endif

     #ifdef USE_RINGS
         check_rings();
     #endif

     check_game_specific_anims();
     check_misc_logic();


     if(!flags.game_over &&
        !flags.stage_complete &&
         flags.game_mode > 1) {
             check_game_over();
             check_score();
                              }

     check_actors();
     check_actors_while_paused();
                                     }


 // One per frame is sufficient for some things
 //
 #ifdef USE_TIPS
     if(flags.tutorial) { check_tips(); }
 #endif // USE_TIPS

 return;
}





// NOTE: Keeps track of game time, and parses the ticks left
//       into human readable format
//
void check_time()
{
 div_t d;
 div_t e;

 if(flags.game_mode != 2) { return; }


 d = div(flags.game_time, 3600);

 flags.clock_min = d.quot;

 e = div(flags.game_time - (d.quot * 3600), 60);
 flags.clock_sec = e.quot;
 flags.clock_sub = e.rem;

 return;
}




// Adjusts score over time
//
void check_score()
{
 int factor = 1;
 int total  = 0;


 // Score shakes when bad things happen
 //
 if(flags.score_shake > 0) { flags.score_shake--; }


 // Roll differential into score over time. The larger the difference,
 // the faster we will update the score. Eventually roll this into a log formula.
 //
 if(flags.score_diff != 0) {

     total = abs(flags.score_diff);
     if(total > 20)   { factor = 2;  }
     if(total > 50)   { factor = 4;  }
     if(total > 100)  { factor = 8;  }
     if(total > 250)  { factor = 16; }
     if(total > 500)  { factor = 32; }
     if(total > 999)  { factor = 64; }
     if(total > 1999) { factor = 128; }
     if(total > 3999) { factor = 256; }
     if(total > 6999) { factor = 512; }

     if(flags.score_diff > 0) { flags.score += factor; flags.score_diff -= factor; }
     if(flags.score_diff < 0) { flags.score -= factor; flags.score_diff += factor; }
                     }

 // Bounds check
 //
 if(flags.score < 0)        { flags.score = 0;        }
 if(flags.score > 99999999) { flags.score = 99999999; }

 return;
}





void check_shaders()
{

 // Used by *quite* a lot of shaders
 //
 seconds += GetFrameTime();


 // Update shaders
 //
 SetShaderValue(wave, secondsLoc, &seconds, SHADER_UNIFORM_FLOAT);

 m_var = flags.mosaic * 0.05;
 SetShaderValue(mosaic, mos_mLoc, &m_var, SHADER_UNIFORM_FLOAT);


 // Update Cut-out scroll shader
 //
 scroll_vars[0] += 0.0003;
 scroll_vars[1] += 0.0005;

 scroll_vars[2] -= 0.0004;
 scroll_vars[3] += 0.00025;

 return;
}





// NOTE: General-purpose animations (should be relatively the same per-project)
//
void check_animations()
{
 int i = 0;
 int SET = 0;

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].anim_set) {
         SET = actors[i].anim_set;

         actors[i].anim_timing++;

         // Check for frame advance
         //
         if(actors[i].anim_timing >= anim[SET].timing[actors[i].anim_step]) {
             actors[i].anim_step++;
             actors[i].anim_timing = 0;

             // Check for end, or looping
             //
             if(actors[i].anim_step >= anim[SET].total_frames) {
                 if(actors[i].anim_loop) {
                     actors[i].anim_step = 0;
                     actors[i].anim_timing = 0;
                     actors[i].anim_loop--;
                                         }

                 else { actors[i].anim_set = 0; }
                                                               }
                                                                            }

         // If anim is still set, update frame
         // ** SHOULD PLACE IN ROUTINE SO WE CAN SANITY CHECK ANIM_STEP VALUE **
         //
         if(actors[i].anim_set) {
             SET = actors[i].anim_set;
             actors[i].cel_x = anim[SET].frame_x[actors[i].anim_step];
             actors[i].cel_y = anim[SET].frame_y[actors[i].anim_step];
                                }
                                                 }
                             }

 // Signal tracking
 //
 if(flags.show_signal != -1) {
     flags.signal_time++;
     if(flags.signal_time > flags.signal_max_time) {
         flags.signal_time = 0;
         flags.signal_max_time = 0;
         flags.show_signal = -1;
                                                   }
                             }

 #ifdef USE_BULLETIN
     Vector2 len = { 0 };
     if(bulletin.enabled && bulletin.time_left > 0) { bulletin.time_left--; }

     bulletin.x += bulletin.speed;
     len = MeasureTextEx(bulletin.font, bulletins[bulletin.message], bulletin.font.baseSize * bulletin.f_scale, bulletin.f_spacing);

     if(bulletin.x > len.x) { bulletin.x -= len.x; }

 #endif


 // Full-screen tint tracking
 //
 if(flags.tint_velocity != 0.0) {
     flags.tint_str += flags.tint_velocity;
     if(flags.tint_str >= 1.00) { flags.tint_str = 1.00; flags.tint_velocity = 0.0; }
     if(flags.tint_str <= 0.00) { flags.tint_str = 0.00; flags.tint_velocity = 0.0; }
                                }


 // Mosaic tracking
 //
 if(flags.mosaic_velocity != 0.0) {
     flags.mosaic += flags.mosaic_velocity;
     if(flags.mosaic >= 1.00) { flags.mosaic = 1.00; flags.mosaic_velocity = 0.0; }
     if(flags.mosaic <= 0.00) { flags.mosaic = 0.00; flags.mosaic_velocity = 0.0; }
                                  }


 // Game speed tracking
 //
 if(flags.game_velocity != 0.0) {
     flags.game_speed += flags.game_velocity;
     if(flags.game_speed >= 1.00) { flags.game_speed = 1.00; flags.game_velocity = 0.0; }
     if(flags.game_speed <= 0.00) { flags.game_speed = 0.00; flags.game_velocity = 0.0; }
                                  }


 // Floating object animation
 //
 anims[2] += 1.0;
 if(anims[2] > 360.00) { anims[2] -= 360.00; }


 // Medium flashing indicator timer
 //
 anims[3] += 0.01;
 if(anims[3] > 1.00) { anims[3] -= 1.00; }


 // UI selection pulsing animation
 //
 anims[4] += 4.0;
 if(anims[4] > 360.00) { anims[4] -= 360.00; }


 // Quake damage pulsing (fed into sin())
 //
 anims[5] += 8.0;
 if(anims[5] > 360.00) { anims[5] -= 360.00; }


 // Holding position shuffle (slow, lazy sine)
 //
 anims[6] += 0.01;
 if(anims[6] > 360.00) { anims[6] -= 360.00; }


 // Flashing Title indicator (50% to 100% opacity)
 //
 anims[7] += 0.04;
 if(anims[7] > 360.00) { anims[7] -= 360.00; }


 // Stripe banner sliding animation
 //
 anims[8] += 1.0;
 if(anims[8] > 32.00) { anims[8] -= 32.00; }


 // Signal fade
 //
 anims[9] -= 0.01;
 if(anims[9] < 0.00) { anims[9] = 0.00; }


 // Cloud scrolling animation
 //
 anims[10] += 2.0;
 if(anims[10] >= 1024) { anims[10] -= 1024; }


 // Pumpkin mouth tilt animation
 //
 anims[13] += 2.0;
 if(anims[13] >= 360.00) { anims[13] -= 360.00; }


 // Title emoji animation
 //
 anims[14] += 1.5;
 if(anims[14] >= 360.00) { anims[14] -= 360.00; }


 // Title emoji animation
 //
 anims[15] += 0.5;
 if(anims[15] >= 360.00) { anims[15] -= 360.00; }


 return;
}






// Kills off dead actors, spawns new ones over time
//
void check_actors()
{
 int i           = 0;
 int k           = 0;
 int check       = 0;
 float dist      = 0.0;

 if(flags.paused) { return; }

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         // Actor is quaking
         //
         if(actors[i].quake > 0.000) {
             actors[i].angle = sin(anims[5]) * actors[i].quake;
             actors[i].quake -= 0.10;
             if(actors[i].quake <= 0.000) {
                 actors[i].angle = 0.0;
                 actors[i].quake = 0.0;
                                          }
                                     }

         // Actor is jittering (Y axis)
         //
         if(actors[i].jitter_y) {
             actors[i].jitter_y--;
             if(actors[i].jitter_y < 0) { actors[i].jitter_y = 0; }
                                }


         // Actor is sprite rolling, angle rolling, or flickering
         //
         if(actors[i].roll > 0.001 || actors[i].roll < -0.001) { actors[i].angle += actors[i].roll; }
         if(actors[i].v_roll > 0.001 || actors[i].v_roll < -0.001) { actors[i].v_angle += actors[i].v_roll; }


         switch(actors[i].state) {
             case 0: // Inactive
                     break;

             case 1: // Fades out quickly and expires (player trail)
                     actors[i].blend -= 0.035;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

             case 2: // Rises. Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].flicker = 0;
                         actors[i].pos.z += 1.0;
                         actors[i].pos.x += actors[i].path.x;
                         actors[i].blend -= 0.005;
                         if(actors[i].blend <= 0.00) { kill_actor(i); }
                                                }
                     break;

             case 3: // Fades out quickly and expires (bullet trail)
                     actors[i].blend -= 0.05;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

             case 5: // Friendly Shot: Angle + speed movement
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].inert = 1;
                         actors[i].blend -= 0.06;
                         if(actors[i].blend <= 0.0) { kill_actor(i); break; }
                                                }

                     if(actors[i].inert > 0) { break; }


                     // Check for collision
                     //
                     for(k=0; k<MAX_ACTORS; k++) {
                         if(actors[k].enabled &&
                            actors[k].team == 2 &&
                            !actors[k].inert) {
                                dist = dist_2d(actors[i].pos.x, actors[i].pos.y - actors[i].pos.z - 8,
                                                  actors[k].pos.x, actors[k].pos.y - actors[k].pos.z - 32);
                                if(dist < 40) { destroy_enemy(k, i); break; }
                                            }
                                                 }

                     break;

             case 6: // Enemy ship: Angle + speed movement
                     if(!actors[i].preference) {
                         actors[i].v_angle = 270.0;
                         actors[i].last_angle += 3.0;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                                               }
                     else {
                         actors[i].v_angle = 90.0;
                         actors[i].last_angle += 3.0;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                          }

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y = actors[i].path.y + (sin(TO_RADIANS(actors[i].last_angle)) * 50.0);

                     if(!actors[i].preference) { // Moving left
                         if(actors[i].pos.x < -50) {
                             kill_actor(i);
                             flags.sum_escapes++;
                             flags.score_diff -= 100;
                                                   }
                                               }
                     else { // Moving right
                         if(actors[i].pos.x > SCREEN_W + 50) {
                             kill_actor(i);
                             flags.sum_escapes++;
                             flags.score_diff -= 100;
                                                             }
                          }
                     break;

             case 7: // Pixel tracking (Angle movement + collision tracking)
                     actors[i].pos.x += sin(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     check = field_collision(i);
                     if(check) { kill_actor(i); break; }

                     actors[i].stamina--;
                     if(actors[i].stamina < 0) { kill_actor(i); }
                     break;

             case 8: // Antimatter Pixel tracking
                     actors[i].pos.x += sin(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     check = antimatter_collision(i);
                     if(check) { kill_actor(i); break; }

                     actors[i].stamina--;
                     if(actors[i].stamina < 0) { kill_actor(i); }
                     break;

             case 9: // YO block tracking
                     if(!actors[i].preference) {
                         actors[i].v_angle = 270.0;
                         actors[i].last_angle += 1.5;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                                               }
                     else {
                         actors[i].v_angle = 90.0;
                         actors[i].last_angle += 1.5;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                          }

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y = actors[i].path.y + (sin(TO_RADIANS(actors[i].last_angle)) * 80.0);

                     actors[i].color = ColorFromHSV(anims[4], 1.0, 1.0);

                     if(!actors[i].preference) { // Moving left
                         if(actors[i].pos.x < -50) { kill_actor(i); }
                                               }
                     else { // Moving right
                         if(actors[i].pos.x > SCREEN_W + 50) { kill_actor(i); }
                          }
                     break;

            case 10: // Remnant tracking (Angle movement + collision tracking)
                     actors[i].pos.x += sin(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina < 0) { kill_actor(i); }

                     actors[i].blend -= 0.005;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }

                     break;

            case 11: // Launched Moai
                     actors[i].pos.y -= actors[i].path.y;
                     actors[i].path.y *= 1.03;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         PlaySound(sfx[14]);
                         clear_field_color(actors[i].extra[0]);
                         flags.quake_duration = 30;
                         kill_actor(i);
                                                }
                     break;

            case 12: // Debris tracking
                     actors[i].pos.x += sin(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(TO_RADIANS(actors[i].v_angle)) * actors[i].v_speed;

                     actors[i].blend -= 0.015;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 13: // Brown Bomber block tracking
                     if(!actors[i].preference) {
                         actors[i].v_angle = 270.0;
                         actors[i].last_angle += 1.5;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                                               }
                     else {
                         actors[i].v_angle = 90.0;
                         actors[i].last_angle += 1.5;
                         if(actors[i].last_angle > 360.00) { actors[i].last_angle -= 360.00; }
                          }

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y = actors[i].path.y + (sin(TO_RADIANS(actors[i].last_angle)) * 80.0);

                     if(!actors[i].preference) { // Moving left
                         if(actors[i].pos.x < -50) { kill_actor(i); }
                                               }
                     else { // Moving right
                         if(actors[i].pos.x > SCREEN_W + 50) { kill_actor(i); }
                          }
                     break;

            case 19: // Human goes flying off (got bonked to death)
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.y += actors[i].path.y;
                     actors[i].pos.z += actors[i].path.z;

                     actors[i].path.z -= GRAVITY_PULL;
                     actors[i].angle  += actors[i].roll;

                     actors[i].blend -= 0.01;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 42: // Reserved for Douglas Adams
                     break;

            case 99: // Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

                                 }
                           }
                             }

 // Should move following to a secondary pass, so movement and followers are synchronized
 // no matter where they fall in the actor list
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {

         // Actor is following another
         //
         if(actors[i].following != -1) {
             k = actors[i].following;
             actors[i].pos.x = actors[k].pos.x + actors[i].follow_x;
             actors[i].pos.y = actors[k].pos.y + actors[i].follow_y; // + 99;
             ///actors[i].pos.z = actors[k].pos.z + 64;
                                       }
                           }
                             }

 return;
}





// NOTE: Checks for "game over" and "Stage complete" conditions
//       These will vary between projects
//
void check_game_over()
{

 if(flags.game_mode != 2) { return; }

 // Save this code to show what you want to do on a stage complete/game over event
 /*
 if(flags.sacrifice_meter == 10 && !flags.stage_complete) {
     tint_velocity = 0.01;
     tint_col      = BLACK;
     tint_str      = 0.00;
     display_signal(0);
     flags.stage_complete = 1;
                                                          }
 */

 if(is_game_over() && !flags.game_ending) {
     flags.covered++;

     if(flags.covered > 180) {

         if(!flags.covered_countdown && flags.covered_sub >= 58) { kill_player(); }

         flags.covered_sub++;
         if(flags.covered_sub >= 60) {
             flags.covered_sub = 0;
             if(flags.covered_countdown > 0) { flags.covered_countdown--; }
                                     }
                             }
                                                    }
 else {
     flags.covered = 0;
     flags.covered_sub = 0;
     flags.covered_countdown = 10;
      }

 if(flags.mosaic > 0.80 && flags.game_ending && !flags.game_over) { flags.game_over = 1; }

 if(IsKeyDown(KEY_ESCAPE)) {
     hotkey_toggles[0] = 1;
     flags.game_over   = 1;
                           }
 else { hotkey_toggles[0] = 0; }

 return;
}






// NOTE: This can be cleared out per-project
//
void check_game_specific_anims()
{
 int spawn_rate = 1000;
 int brown_rate = 2000;

 if(flags.paused) { return; }
 if(flags.game_mode != 2) { return; }

 update_field();

 if(is_container_full(0)) { launch_moai(0); flags.score_diff += 10000; flags.sum_launches++; }
 if(is_container_full(1)) { launch_moai(1); flags.score_diff += 10000; flags.sum_launches++; }
 if(is_container_full(2)) { launch_moai(2); flags.score_diff += 10000; flags.sum_launches++; }

 // Check game time and use that to determine spawn rate
 //
 switch(flags.clock_min) {
     case 0: spawn_rate =  900; break;
     case 1: spawn_rate =  800; break;
     case 2: spawn_rate =  700; break;
     case 3: spawn_rate =  600; break;
     case 4: spawn_rate =  500; break;
                         }
 if(flags.clock_min > 4) { spawn_rate = 400; }

 if(quick_rand(spawn_rate) < 5) { spawn_wave(); }


 // brown bomber blocks randomly spawn at an increasing rate,
 // capped over time (max rate at 10 minutes ingame)
 //
 brown_rate = 2000 - (100 * flags.clock_min);
 if(brown_rate < 1000) { brown_rate = 1000; }

 if(quick_rand(brown_rate) < 1) { spawn_brown_bomber_block(); }


 // Check score for YO! block viability (log this calc)
 //
 if(flags.score >= flags.next_yo) {
     spawn_yo_block();
     flags.next_yo += (float)(flags.yo_factor * 5000.0);
     flags.yo_factor += 1.25;
                                  }

 return;
}





// NOTE: Project-specific random logic (as in not tied to an actor)
//       should be tossed in here
//
void check_misc_logic()
{

 if(flags.game_mode < 2) { return; }

 return;
}





// NOTE: Same as above, but only includes behaviors that must be
//       available during a system/event pause
//       This is janky, but I'm not building a huge framework (again) for all this
//
void check_actors_while_paused()
{

 return;
}





// Populates end-game summary with information
// Can be called at the end of a game session, or per-frame
//
void check_summary()
{

 summary_data[0] = flags.sum_launches;
 summary_data[1] = flags.sum_hits;
 summary_data[2] = flags.sum_escapes;
 summary_data[3] = flags.sum_yos;

 summary_data[15] = flags.score; // Score is always last item (jank, I know)

 return;
}



