#include "Project.h"

#ifdef USE_TEXTBOX


// Lotta opportunities to clean this shit up and get it modernized. Not today though.
//
// Using easings to get boxes to "pop" in
// making font, margins, and spacing variable
// Long term - an auto-sizing routine like I used for Inimicus
//

void check_textbox()
{
 int i = 0;
 int len = 0;

 for(i=0; i<MAX_TEXTBOX; i++) {
     if(textbox[i].enabled) {
         switch(textbox[i].mode) {
                     break;

             case 0: // Entering
                     textbox[i].scale += 0.075;
                     if(textbox[i].scale >= 1.00) { textbox[i].scale = 1.00; textbox[i].mode++; }
                     break;

             case 1: // Displaying text
                     len = strlen(textbox[i].msg);
                     if(textbox[i].viewable_text < len) {
                         textbox[i].ticks++;
                         if(textbox[i].ticks /*> 3*/) { textbox[i].viewable_text++; /*PlaySound(sfx[5]);*/ textbox[i].ticks = 0; }
                                                        }
                     else { textbox[i].ticks++; } // Keep counting ticks, in case useful

                     if(textbox[i].duration != -1) {
                         if(textbox[i].ticks > textbox[i].duration) { if(!textbox[i].hold) { textbox[i].mode = 2; } }
                                                   }
                     break;

             case 2: // Exiting
                     textbox[i].viewable_text = 0;
                     textbox[i].scale -= 0.075;
                     if(textbox[i].scale <= 0.00) { textbox[i].scale = 0.00; textbox[i].enabled = 0; }
                     break;
                                 }

         if(textbox[i].mode < 0) { textbox[i].mode++; } // Pause before beginning, effectively

                            }
                              }

 // Update background texture position
 //
 if(!box_update) {
     box_tex_x -= 0.50;
     box_tex_y += 0.50;
     box_update = 1;
                   }

 else { box_update = 0; }

 return;
}




void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration)
{

 // Sanity check slot and message

 textbox[slot].pos.x      = x;
 textbox[slot].pos.y      = y;
 textbox[slot].pos.width  = w;
 textbox[slot].pos.height = h;
 textbox[slot].scale      = 0.0;
 textbox[slot].text_scale = 4.0;
 textbox[slot].duration   = duration;
 textbox[slot].mode       = 0 - delay;
 textbox[slot].ticks      = 0;
 textbox[slot].viewable_text = 0;
 textbox[slot].msg        = textbox_messages[message];
 textbox[slot].hold       = 0;
 textbox[slot].enabled    = 1;

 return;
}




// NOTE: Typical usage is to put the box over a character or tile's position
//       Be mindful of where this occurs in your drawing pipeline. If the
//       2D/3D cam is enabled, the box will go where the fuck ever instead
//       of where you're expecting.
//
void draw_text_box(int slot)
{
 Rectangle dest;

 Vector2 text_coords;
 Vector2 text_len;
 Vector2 origin = { 0 };


 if(!textbox[slot].enabled) { return; }
 if(textbox[slot].mode < 0) { return; }


 // Calculate textbox dimensions, etc
 //
 dest.width  = textbox[slot].pos.width  * textbox[slot].scale;
 dest.height = textbox[slot].pos.height * textbox[slot].scale;

 dest.x = textbox[slot].pos.x - (dest.width / 2.0f);
 dest.y = textbox[slot].pos.y - (dest.height / 2.0f);


 // Draw border around box
 //
 DrawRectangleLinesEx(dest, 4, WHITE);


 // Draw tiled texture (happy face) and update anchor coordinates
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 128, 16 };
 Rectangle tex_d = { dest.x+3, dest.y+3, dest.width - 6, dest.height - 6 };

 SetTextureWrap(box_tex, TEXTURE_WRAP_REPEAT);
 DrawTexturePro(box_tex, tex_s, tex_d, origin, 0.0, Fade(WHITE, 0.90));


 if(!textbox[slot].viewable_text) { return; }


 // Make a copy first because strtok clobbers the source
 //
 char *token = NULL;
 char clone[256];
 int lengths[256];
 int line           = 0;
 int total_lines    = 0;
 float total_height = 0;
 float line_cutoff  = textbox[slot].pos.width * 0.90;
 float line_width   = 0.0;
 Vector2 space      = { 0 };
 Vector2 line_check = { 0 };

 memset(&lengths[0], 0, 256);

 space = MeasureTextEx(font1, " ", (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale);



 // Tokenize string (FIRST PASS, FOR TOTAL LINES)
 //
 memset(&clone[0], 0, 256);
 strncpy(&clone[0], textbox[slot].msg, strlen(textbox[slot].msg));

 token = strtok(&clone[0], " ,");
 while(token != NULL) {
     line_check = MeasureTextEx(font1, (const char *)token, (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale);
     if((line_width + line_check.x) > line_cutoff) {
         lengths[line] = line_width; // record for use below
         line++;
         line_width = 0;
         line_width = (line_check.x + space.x);
                                                   }
     else {
         line_width += (line_check.x + space.x);
          }

     token = strtok(NULL, " ,");
                      }


 total_lines = (line + 1); // Note the +1, please
 line        = 0;
 line_width  = 0;



 // If we only have one line, we will center the text horizontally and vertically
 // NOTE FOR LATER: THIS SHOULD BE AN OPTION ^^^
 //
 if(total_lines == 1) {
     text_len = MeasureTextEx(font1, textbox[slot].msg, (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale);
     text_coords.x = dest.x + (dest.width / 2)     - (text_len.x / 2);
     text_coords.y = dest.y + (dest.height / 2.0f) - (text_len.y / 2);
                      }
 else {                                       // vvvv PARAMETERIZE THESE (0.25, 0.05)
     total_height = (space.y * total_lines) + ((space.y * 0.25) * (total_lines - 1));
     text_coords.x = dest.x + (dest.width * 0.05);
     text_coords.y = dest.y + ((dest.height / 2.0f) - (total_height / 2));
      }



 // Tokenize string (SECOND PASS, FOR REAL THIS TIME)
 //
 memset(&clone[0], 0, 256);
 strncpy(&clone[0], textbox[slot].msg, strlen(textbox[slot].msg));

 token = strtok(&clone[0], " ,");
 while(token != NULL) {
     line_check = MeasureTextEx(font1, (const char *)token, (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale);
     if((line_width + line_check.x) > line_cutoff) {
         line++;
         line_width = 0;
         DrawTextEx(font1, (const char *)token, (Vector2){text_coords.x + (line_width), text_coords.y + (line * space.y) + ((space.y * 0.25) * line)}, (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale, WHITE);
         line_width = (line_check.x + space.x);
                                                   }
     else {
         DrawTextEx(font1, (const char *)token, (Vector2){text_coords.x + (line_width), text_coords.y + (line * space.y) + ((space.y * 0.25) * line)}, (font1.baseSize * textbox[slot].text_scale), textbox[slot].text_scale, WHITE);
         line_width += (line_check.x + space.x);
          }

     token = strtok(NULL, " ,");
                      }




/*

 // Draw characters
 //
 if(textbox[slot].viewable_text > 0) {
     memset(strang, 0, sizeof(strang));
     strncpy(strang, textbox[slot].msg, textbox[slot].viewable_text);
     DrawTextEx(font1, strang, text_coords, (font1.baseSize * textbox[slot].text_scale), 1, WHITE);
                                     }
*/

 return;
}




/*
// NOTE: This got fugly in a hurry. Wow.
//
void PR_render_popup()
{
 int line           = 0.0;
 float width        = 0.0;
 float scale        = 0.0;
 float full_scale   = 2.0;
 float line_width   = 0.0;
 float offset       = 0.0;
 float line_cutoff  = 320.00;

 Vector2 dest       = { 0 };
 Vector2 origin     = { 0 };
 Vector2 space      = { 0 };
 Vector2 full_space = { 0 };
 Vector2 check      = { 0 };
 Vector2 line_check = { 0 };
 Rectangle dest_r   = { 0 };


 if(pop_up.stage == 1) { scale  = FR_easing_pop_in(pop_up.ticks, 0, 90, 0.0, 2.0, FR_POP_STANDARD); }
 if(pop_up.stage == 3) { scale  = FR_easing_pop_in(pop_up.ticks, 0, 90, 2.0, 0.0, FR_POP_STANDARD); }
 if(pop_up.stage == 2) { scale  = 2.00; }

 dest.x = pop_up.pos.x - ((t_bubble.width  * scale) / 2.0);
 dest.y = pop_up.pos.y - ((t_bubble.height * scale) / 2.0);
 DrawTextureEx(t_bubble, dest, 0.0, scale, WHITE);

 dest_r.x = pop_up.pos.x - ((t_bubble.width  * scale) / 2.15);
 dest_r.y = pop_up.pos.y - ((t_bubble.height * scale) / 2.73);
 dest_r.width  = 48.0 * scale;
 dest_r.height = 48.0 * scale;
 DrawTexturePro(t_48x, (Rectangle){(48.0 * pop_up.icon), 0.0, 48.0, 48.0}, dest_r, origin, 0.0, WHITE);

 space      = MeasureTextEx(font_6, " ",  font_6.baseSize * (scale / 2.0), scale * 2.0);
 full_space = MeasureTextEx(font_6, " ",  font_6.baseSize * 1.0, full_scale * 2.0);


 // Parses the string. Make a copy first because strtok clobbers the source
 //
 char *token = NULL;
 char clone[256];


 // Execute once to get total number of lines (for vertical spacing, below)
 //
 memset(&clone[0], 0, 256);
 strncpy(&clone[0], t_messages[pop_up.message], strlen(t_messages[pop_up.message]));

 token = strtok(&clone[0], " ,");
 while(token != NULL) {
     check      = MeasureTextEx(font_6, (const char *)token, font_6.baseSize * (scale / 2.0), scale * 2.0);
     line_check = MeasureTextEx(font_6, (const char *)token, font_6.baseSize * 1.0, full_scale * 2.0);
     if((line_width + line_check.x) > line_cutoff) {
         line++;
         width = 0; line_width = 0;
         width      = (check.x + space.x);
         line_width = (line_check.x + full_space.x);
                                                   }
     else {
         width      += (check.x + space.x);
         line_width += (line_check.x + full_space.x);
          }

     token = strtok(NULL, " ,");
                      }



 // Execute for real this time
 //
 if(line == 0) { offset = (15  * scale); }
 if(line == 1) { offset = (7.5 * scale); }
 if(line == 2) { offset = 0.0;           }
 line = 0;
 width = 0;
 line_width = 0;

 memset(&clone[0], 0, 256);
 strncpy(&clone[0], t_messages[pop_up.message], strlen(t_messages[pop_up.message]));

 token = strtok(&clone[0], " ,");
 while(token != NULL) {
     check      = MeasureTextEx(font_6, (const char *)token, font_6.baseSize * (scale / 2.0), scale * 2.0);
     line_check = MeasureTextEx(font_6, (const char *)token, font_6.baseSize * 1.0, full_scale * 2.0);
     if((line_width + line_check.x) > line_cutoff) {
         line++;
         width = 0; line_width = 0;
         DrawTextEx(font_6, (const char *)token, (Vector2){dest.x + (80 * scale) + width, dest.y + offset + (12 * scale) + ((15 * scale) * line)}, font_6.baseSize * (scale / 2.0), scale * 2.0, BLACK);
         width      = (check.x + space.x);
         line_width = (line_check.x + full_space.x);
                                                   }
     else {
         DrawTextEx(font_6, (const char *)token, (Vector2){dest.x + (80 * scale) + width, dest.y + offset + (12 * scale) + ((15 * scale) * line)}, font_6.baseSize * (scale / 2.0), scale * 2.0, BLACK);
         width      += (check.x + space.x);
         line_width += (line_check.x + full_space.x);
          }

     token = strtok(NULL, " ,");
                      }


 return;
}
*/




#endif




/*
void draw_text_box(int slot)
{
 Rectangle dest;
 char strang[80];

 Vector2 text_coords;
 Vector2 text_len;
 Vector2 origin = { 0 };


 if(!textbox[slot].enabled) { return; }
 if(textbox[slot].mode < 0) { return; }


 // Calculate textbox dimensions, etc
 //
 dest.width  = textbox[slot].pos.width  * textbox[slot].scale;
 dest.height = textbox[slot].pos.height * textbox[slot].scale;

 dest.x = textbox[slot].pos.x - (dest.width / 2.0f);
 dest.y = textbox[slot].pos.y - (dest.height / 2.0f);


 // Draw border around box
 //
 DrawRectangleLinesEx(dest, 4, WHITE);


 // Draw tiled texture (happy face) and update anchor coordinates
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 128, 32 };
 Rectangle tex_d = { dest.x+3, dest.y+3, dest.width - 6, dest.height - 6 };

 SetTextureWrap(box_tex, TEXTURE_WRAP_REPEAT);
 DrawTexturePro(box_tex, tex_s, tex_d, origin, 0.0, Fade(WHITE, 0.90));


 // Measure text and box and figure out how to center text
 //
 text_len = MeasureTextEx(font5, textbox[slot].msg, (font5.baseSize * textbox[slot].text_scale), 1);

 text_coords.x = dest.x + (dest.width / 2)     - (text_len.x / 2);
 text_coords.y = dest.y + (dest.height / 2.0f) - (text_len.y / 2);


 // Draw characters
 //
 if(textbox[slot].viewable_text > 0) {
     memset(strang, 0, sizeof(strang));
     strncpy(strang, textbox[slot].msg, textbox[slot].viewable_text);
     DrawTextEx(font5, strang, text_coords, (font5.baseSize * textbox[slot].text_scale), 1, WHITE);
                                     }

 return;
}

*/
